//+------------------------------------------------------------------+
//|                                               Ost_Lots_Volue.mq4 |
//|                                                 Nikolaj Ostapjuk |
//|                                                 nikost3@inbox.lv |
//+------------------------------------------------------------------+
#property copyright "Nikolaj Ostapjuk"
#property link      "nikost3@inbox.lv"
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 PaleGreen
#property indicator_color2 MediumBlue
#property indicator_color3 Gold
#property indicator_color4 Sienna
#property indicator_level1 20
#property indicator_level2 50
#property indicator_level3 80
//---- input parameters
extern string Sym1 = "_SP500";
extern string Sym2 = "_GC";
extern string Sym3 = "_QM";
extern int fast   = 3;
extern int slow   = 14;
extern int CountBars = 55;
//---- buffers 
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double Buffer01[];
double Buffer02[];
double Buffer03[];
double Buffer04[];
string         indicname;
int            window = -1;
double PointSym1,PointSym2,PointSym3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {  
   indicname = WindowExpertName(); 
//---- 1 additional buffer used for counting.
   IndicatorBuffers(8);
   IndicatorDigits(Digits);
   PointSym1=MarketInfo(Sym1,MODE_POINT);
   PointSym2=MarketInfo(Sym2,MODE_POINT);
   PointSym3=MarketInfo(Sym3,MODE_POINT);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,Buffer01);
   SetIndexDrawBegin(0,Bars-CountBars+30);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexBuffer(1,Buffer02);
   SetIndexDrawBegin(1,Bars-CountBars+30);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,Buffer03);
   SetIndexDrawBegin(2,Bars-CountBars+30);
   SetIndexStyle(3,DRAW_LINE,0,2);
   SetIndexBuffer(3,Buffer04);
   SetIndexDrawBegin(3,Bars-CountBars+30);
  
   SetIndexBuffer(4,Buffer1);
   SetIndexBuffer(5,Buffer2);
   SetIndexBuffer(6,Buffer3);
   SetIndexBuffer(7,Buffer4);
   SetIndexLabel(0,  "MACD - "+slow);
   SetIndexLabel(1,  "MACD - "+Sym1+" ; "+fast+" ; "+slow);
   SetIndexLabel(2,  "MACD - "+Sym2+" ; "+fast+" ; "+slow);
   SetIndexLabel(3,  "MACD - "+Sym3+" ; "+fast+" ; "+slow);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Bears Power                                                      |
//+------------------------------------------------------------------+
int start()
  {
  int i, nLimit, nCountedBars;  
//---- insufficient data
   if(Bars <= slow)
       return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars = IndicatorCounted();
//----Williams Percent Range calculation
   i = Bars - slow - 1;
   if(nCountedBars > slow) 
       i = Bars - nCountedBars - 1;  
 while(i >= 0)
  {
       Buffer1[i]=(iMA(NULL,0,fast,0,MODE_LWMA,PRICE_CLOSE,i) - 
                   iMA(NULL,0,slow,0,MODE_LWMA,PRICE_CLOSE,i))/Point;               
       Buffer2[i]=(iMA(Sym1,0,fast,0,MODE_LWMA,PRICE_CLOSE,i) - 
                   iMA(Sym1,0,slow,0,MODE_LWMA,PRICE_CLOSE,i))/ PointSym1;
       Buffer3[i]=(iMA(Sym2,0,fast,0,MODE_LWMA,PRICE_CLOSE,i) - 
                   iMA(Sym2,0,slow,0,MODE_LWMA,PRICE_CLOSE,i))/ PointSym2;
       Buffer4[i]=(iMA(Sym3,0,fast,0,MODE_LWMA,PRICE_CLOSE,i) - 
                   iMA(Sym3,0,slow,0,MODE_LWMA,PRICE_CLOSE,i))/ PointSym3;
                                      
    
       i--;

  }
  if(window < 0)
      window = WindowFind(indicname);
    string  Pa1 = Sym1;
         ObjectCreate("DevI", OBJ_LABEL,window , 0, 0);
         ObjectSet("DevI", OBJPROP_CORNER, 1);
         ObjectSet("DevI", OBJPROP_XDISTANCE, 20);
         ObjectSet("DevI", OBJPROP_YDISTANCE, 5);
         ObjectSetText("DevI", Pa1, 10, "Verdana",Blue);
   string  Pa2 = Sym2;
         ObjectCreate("DevI1", OBJ_LABEL,window , 0, 0);
         ObjectSet("DevI1", OBJPROP_CORNER, 1);
         ObjectSet("DevI1", OBJPROP_XDISTANCE, 20);
         ObjectSet("DevI1", OBJPROP_YDISTANCE, 20);
         ObjectSetText("DevI1", Pa2, 10, "Verdana",Gold);
   string  Pa3 = Sym3;
         ObjectCreate("DevI2", OBJ_LABEL,window , 0, 0);
         ObjectSet("DevI2", OBJPROP_CORNER, 1);
         ObjectSet("DevI2", OBJPROP_XDISTANCE, 20);
         ObjectSet("DevI2", OBJPROP_YDISTANCE, 35);
         ObjectSetText("DevI2", Pa3, 10, "Verdana",Sienna);
//----
   i=Bars-nCountedBars -1;
   while(i>=0)
     {
      if(Buffer1[i]>0.0) double powerUp=Buffer1[i];
      if(Buffer1[i]<0.0) double powerDw=Buffer1[i];
             Buffer01[i]=100.0*powerUp/(powerUp-powerDw);
      if(Buffer2[i]>0.0) double sym1Up=Buffer2[i];
      if(Buffer2[i]<0.0) double sym1Dw=Buffer2[i];
             Buffer02[i]=100.0*sym1Up/(sym1Up-sym1Dw); 
      if(Buffer3[i]>0.0) double sym2Up=Buffer3[i];
      if(Buffer3[i]<0.0) double sym2Dw=Buffer3[i];
             Buffer03[i]=100.0*sym2Up/(sym2Up-sym2Dw); 
      if(Buffer4[i]>0.0) double sym3Up=Buffer4[i];
      if(Buffer4[i]<0.0) double sym3Dw=Buffer4[i]; 
             Buffer04[i]=100.0*sym3Up/(sym3Up-sym3Dw);
      i--;
     }                     
   i=Bars-nCountedBars -1;
   while(i>=0)
     {
             //BufferNull[i]=iMAOnArray(Buffer01,0,slow,0,MODE_SMA,i);
      
            // BufferSym[i]=iMAOnArray(Buffer02,0,slow,0,MODE_SMA,i);
      i--;
     }                                                      
   return(0);
}
//+------------------------------------------------------------------+ 



